# Tkppp
# PPP dialup tool with Tk Interface

# global variables

set TimerVar "00:00:00"
set TimerCount 0

set ScriptVar(name) "No script"
set ScriptVar(phone) "---"
set ScriptVar(login) "---"
set ScriptVar(password) "---"
set ScriptVar(noipdefault) "Yes"
set ScriptVar(debug) "Yes"
set ScriptVar(ipsource) "0.0.0.0"
set ScriptVar(ipdest) ""
set ScriptVar(modemdev) "/dev/cua1"
set ScriptVar(modemspeed) "9600"
set ScriptVar(crtscts) "Yes"

set ConnectVar "Connect"

set TitleVar Tkppp
set VersionVar 0.1

set pppid 0

# widgets hierarchy

#info frame

frame .infoframe -background darkblue

label .timerlabel -textvariable TimerVar -relief sunken -background blue -foreground yellow -font -adobe-times-*-*-*-*-0-0-150-150-p-0-iso8859-1 

label .scriptlabel -textvariable ScriptVar(name) -background blue -relief groove -foreground white

#other buttons

button .connectbutton -textvariable ConnectVar -background mediumblue -activebackground blue -foreground gray90 -activeforeground gray90  -command GoConnect

button .configurebutton -text "Configure" -background mediumblue -activebackground blue -foreground gray90 -activeforeground gray90 -command GoConfigure
 
button .quitbutton -text "Quit" -command "exit 0" -background mediumblue -activebackground blue -foreground gray90 -activeforeground gray90

wm title . "$TitleVar $VersionVar"
#wm resizable . 0 0

#packing widgets

pack .infoframe -side left -fill both -expand 1
pack .timerlabel -in .infoframe -padx 8 -pady 8 -ipadx 4 -ipady 4 -fill both -expand 1
pack .scriptlabel -in .infoframe -ipadx 4 -ipady 4 -padx 8 -pady 8 -fill both -expand 1

pack .connectbutton -side left -fill both -expand 1 -padx 2 -pady 2
pack .configurebutton -side left -fill both -expand 1 -padx 2 -pady 2
pack .quitbutton -side right -fill both -expand 1 -padx 2 -pady 2

#procedures

proc MakeTimeVar { tc } {
    set hours [expr $tc / 3600]
    set hours [format "%d" $hours]
    set tc [expr $tc -($hours*3600)]
    set minutes [expr $tc / 60]
    set minutes [format "%d" $minutes]
    set tc [expr $tc -($minutes*60)]
    return [format "%02d:%02d:%02d" $hours $minutes $tc]
}

# Connection/Deconnection procedure

proc GoConnect {} {
    global ConnectVar TimerCount ScriptVar
    
    if { $ConnectVar == "Connect" } {
	set file [open ppptmp w]
	
	puts $file "\"\" ATZ OK ATDT$ScriptVar(phone) CONNECT \"\" ogin: $ScriptVar(login) word: $ScriptVar(password) \ "

        close $file

	exec goppp $ScriptVar(modemdev) $ScriptVar(modemspeed) $ScriptVar(noipdefault) $ScriptVar(debug) $ScriptVar(crtscts) $ScriptVar(ipsource) $ScriptVar(ipdest) &

	set ConnectVar "Deconnect"
	set TimerCount 0
	RunTimer
    } else { 

#  First, I wanted to use kill but if you have more than one modem
# I don't know which pppd I've killed !
 
#	exec ps -h | grep pppd > pppend
#	set f [open pppend r]
#	gets $f psresult
#	close $f
#	scan $psresult "  %d " pppid
#	exec kill -9 $pppid
#	exec rm -f pppend

# so I launch a new pppd for the same interface and end the connection,
# it works better !

        exec killppp $ScriptVar(modemdev) $ScriptVar(modemspeed)
	exec rm -f ppptmp
	set ConnectVar "Connect" 
    }
}

proc RunTimer {} {
    global ConnectVar TimerCount TimerVar
    if { $ConnectVar=="Deconnect" } {
	incr TimerCount 1
	set TimerVar [MakeTimeVar $TimerCount]
	after 1000 RunTimer
    }
}

proc LoadInitScript { fname } {
    global ScriptVar

    set file [open $fname r]

    set line [gets $file]
    scan $line "name: %s" ScriptVar(name)

    set line [gets $file]
    scan $line "phone: %s" ScriptVar(phone)

    set line [gets $file]
    scan $line "ipsource: %s" ScriptVar(ipsource)

    set line [gets $file]
    scan $line "ipdest: %s" ScriptVar(ipdest)

    set line [gets $file]
    scan $line "login: %s" ScriptVar(login)

    set line [gets $file]
    scan $line "password: %s" ScriptVar(password)

    set line [gets $file]
    scan $line "modemdev: %s" ScriptVar(modemdev)

    set line [gets $file]
    scan $line "modemspeed: %s" ScriptVar(modemspeed)
    
    set line [gets $file]
    scan $line "debug: %s" ScriptVar(debug)

    set line [gets $file]
    scan $line "noipdefault: %s" ScriptVar(noipdefault)

    set line [gets $file]
    scan $line "crtscts: %s" ScriptVar(crtscts)

    close $file
}

# Configure procedure

proc GoConfigure {} {
    global ScriptVar

    set ScriptVarList [uplevel [list source [file join pppconfig.tcl]]]

    if { $ScriptVarList != {} } {
       array set ScriptVar $ScriptVarList
    }
}

set default [file exists pppscript.default]

if { $default == 1 } {
    LoadInitScript "pppscript.default"
}

